package provide unicodeblock 1.1

namespace eval unicodeblock {
	namespace export *
	variable unimap {\
		InBasic_Latin 007f \
		InLatin-1_Supplement 00ff \
		InLatin_Extended-A 017f \
		InLatin_Extended-B 024f \
		InIPA_Extensions 02af \
		InSpacing_Modifier_Letters 02ff \
		InCombining_Diacritical_Marks 036f \
		InGreek_and_Coptic 03ff \
		InCyrillic 04ff \
		InCyrillic_Supplementary 052f \
		InArmenian 058f \
		InHebrew 05ff \
		InArabic 06ff \
		InSyriac 074f \
		InThaana 07bf \
		InDevanagari 097f \
		InBengali 09ff \
		InGurmukhi 0a7f \
		InGujarati 0aff \
		InOriya 0b7f \
		InTamil 0bff \
		InTelugu 0c7f \
		InKannada 0cff \
		InMalayalam 0d7f \
		InSinhala 0dff \
		InThai 0e7f \
		InLao 0eff \
		InTibetan 0fff \
		InMyanmar 109f \
		InGeorgian 10ff \
		InHangul_Jamo 11ff \
		InEthiopic 137f \
		InCherokee 13ff \
		InUnified_Canadian_Aboriginal_Syllabics 167f \
		InOgham 169f \
		InRunic 16ff \
		InTagalog 171f \
		InHanunoo 173f \
		InBuhid 175f \
		InTagbanwa 177f \
		InKhmer 17ff \
		InMongolian 18af \
		InLimbu 194f \
		InTai_Le 197f \
		InKhmer_Symbols 19ff \
		InPhonetic_Extensions 1d7f \
		InLatin_Extended_Additional 1eff \
		InGreek_Extended 1fff \
		InGeneral_Punctuation 206f \
		InSuperscripts_and_Subscripts 209f \
		InCurrency_Symbols 20cf \
		InCombining_Diacritical_Marks_for_Symbols 20ff \
		InLetterlike_Symbols 214f \
		InNumber_Forms 218f \
		InArrows 21ff \
		InMathematical_Operators 22ff \
		InMiscellaneous_Technical 23ff \
		InControl_Pictures 243f \
		InOptical_Character_Recognition 245f \
		InEnclosed_Alphanumerics 24ff \
		InBox_Drawing 257f \
		InBlock_Elements 259f \
		InGeometric_Shapes 25ff \
		InMiscellaneous_Symbols 26ff \
		InDingbats 27bf \
		InMiscellaneous_Mathematical_Symbols-A 27ef \
		InSupplemental_Arrows-A 27ff \
		InBraille_Patterns 28ff \
		InSupplemental_Arrows-B 297f \
		InMiscellaneous_Mathematical_Symbols-B 29ff \
		InSupplemental_Mathematical_Operators 2aff \
		InMiscellaneous_Symbols_and_Arrows 2bff \
		InCJK_Radicals_Supplement 2eff \
		InKangxi_Radicals 2fdf \
		InIdeographic_Description_Characters 2fff \
		InCJK_Symbols_and_Punctuation 303f \
		InHiragana 309f \
		InKatakana 30ff \
		InBopomofo 312f \
		InHangul_Compatibility_Jamo 318f \
		InKanbun 319f \
		InBopomofo_Extended 31bf \
		InKatakana_Phonetic_Extensions 31ff \
		InEnclosed_CJK_Letters_and_Months 32ff \
		InCJK_Compatibility 33ff \
		InCJK_Unified_Ideographs_Extension_A 4dbf \
		InYijing_Hexagram_Symbols 4dff \
		InCJK_Unified_Ideographs 9fff \
		InYi_Syllables a48f \
		InYi_Radicals a4cf \
		InHangul_Syllables d7af \
		InHigh_Surrogates db7f \
		InHigh_Private_Use_Surrogates dbff \
		InLow_Surrogates dfff \
		InPrivate_Use_Area f8ff \
		InCJK_Compatibility_Ideographs faff \
		InAlphabetic_Presentation_Forms fb4f \
		InArabic_Presentation_Forms-A fdff \
		InVariation_Selectors fe0f \
		InCombining_Half_Marks fe2f \
		InCJK_Compatibility_Forms fe4f \
		InSmall_Form_Variants fe6f \
		InArabic_Presentation_Forms-B feff \
		InHalfwidth_and_Fullwidth_Forms ffef \
		InSpecials ffff}
}

proc unicodeblock::getblock {char} {
	variable unimap
	if {[string is space $char]} {
		return "InSeparator"
	} elseif {[string is punct $char]} {
		return "InPunctuation"
	}
	set code [char2code $char]
	foreach {block point} $unimap {
		if {$code <= $point} {
			return $block
		}
	}
}

proc unicodeblock::split2list {str} {
	set block {}
	set stack {}
	for {set i 0} {$i < [string length $str]} {incr i} {
		set char [string index $str $i]
		set thisblock [unicodeblock::getblock $char]
		if {$block == $thisblock} {
			append stack $char
		} else {
			if {$stack != ""} {lappend out $stack $block}
			set block $thisblock
			set stack $char
		}
	}
	return [lappend out $stack $block]
}

proc unicodeblock::char2code {char} {
	return [format %04x [scan $char %c]]
}

proc unicodeblock::code2char {code} {
	return [format "%c" 0x$code]
}


